package net.t2code.commandguiv2.Spigot.objects;

import org.bukkit.permissions.PermissionDefault;

import java.util.ArrayList;
import java.util.List;

public class UseItemObject {
    public String key;
    public Boolean enable;
    public String openGui;
    public Boolean allowToggle;
    public Boolean allowSetBlock;
    public Boolean blockMoveAndDrop;

    public Boolean permBecomeNeeded;
    public String permBecome;
    public PermissionDefault permBecomeDefault;

    public Boolean permUseNeeded;
    public String permUse;
    public PermissionDefault permUseDefault;

    public Boolean permToggleNeeded;
    public String permToggle;
    public PermissionDefault permToggleDefault;

    public Boolean permSetSlotNeeded;
    public String permSetSlot;
    public PermissionDefault permSetSlotDefault;

    public Boolean keepAtCommandClear;

    public Integer invSlotSlot;
    public Boolean invSlotEnforce;
    public Boolean invFreeSlot;

    public String itemMaterial;
    public String itemName;
    public List<String> itemLore;
    public Boolean itemPlayerHeadEnable;
    public Boolean itemPlayerHeadPlayerWhoHasOpenedTheGUI;
    public String itemPlayerHeadPlayerName;
    public Boolean itemPlayerHeadBase64Enable;
    public String itemPlayerHeadBase64Value;

    public Boolean joinGiveOnEveryJoin;
    public Boolean joinGiveOnlyOnFirstJoin;

    public Boolean quitRemoveOnQuit;

    public Boolean protectGameModeEnable;
    public Boolean protectGameModeRemoveItemWhenItIsDisabled;
    public String protectGameModeMode;
    public List<String> protectGameModeList;

    public Boolean protectWorldEnable;
    public Boolean protectWorldRemoveItemWhenItIsDisabled;
    public String protectWorldMode;
    public List<String> protectWorldList;

    public UseItemObject(String key,
                         Boolean enable,
                         String openGui,
                         Boolean allowToggle,
                         Boolean allowSetBlock,
                         Boolean blockMoveAndDrop,
                         Boolean permBecomeNeeded,
                         String permBecome,
                         PermissionDefault permBecomeDefault,
                         Boolean permUseNeeded,
                         String permUse,
                         PermissionDefault permUseDefault,
                         Boolean permToggleNeeded,
                         String permToggle,
                         PermissionDefault permToggleDefault,
                         Boolean permSetSlotNeeded,
                         String permSetSlot,
                         PermissionDefault permSetSlotDefault,
                         Boolean keepAtCommandClear,
                         Integer invSlotSlot,
                         Boolean invSlotEnforce,
                         Boolean invFreeSlot,
                         String itemMaterial,
                         String itemName,
                         List<String> itemLore,
                         Boolean itemPlayerHeadEnable,
                         Boolean itemPlayerHeadPlayerWhoHasOpenedTheGUI,
                         String itemPlayerHeadPlayerName,
                         Boolean itemPlayerHeadBase64Enable,
                         String itemPlayerHeadBase64Value,
                         Boolean joinGiveOnEveryJoin,
                         Boolean joinGiveOnlyOnFirstJoin,
                         Boolean quitRemoveOnQuit,
                         Boolean protectGameModeEnable,
                         Boolean protectGameModeRemoveItemWhenItIsDisabled,
                         String protectGameModeMode,
                         List<String> protectGameModeList,
                         Boolean protectWorldEnable,
                         Boolean protectWorldRemoveItemWhenItIsDisabled,
                         String protectWorldMode,
                         List<String> protectWorldList) {
        this.key = key;
        this.enable = enable;
        this.openGui = openGui;
        this.allowToggle = allowToggle;
        this.allowSetBlock = allowSetBlock;
        this.blockMoveAndDrop = blockMoveAndDrop;
        this.permBecomeNeeded = permBecomeNeeded;
        this.permBecome = permBecome;
        this.permBecomeDefault = permBecomeDefault;
        this.permUseNeeded = permUseNeeded;
        this.permUse = permUse;
        this.permUseDefault = permUseDefault;
        this.permToggleNeeded = permToggleNeeded;
        this.permToggle = permToggle;
        this.permToggleDefault = permToggleDefault;
        this.permSetSlotNeeded = permSetSlotNeeded;
        this.permSetSlot = permSetSlot;
        this.permSetSlotDefault = permSetSlotDefault;
        this.keepAtCommandClear = keepAtCommandClear;
        this.invSlotSlot = invSlotSlot;
        this.invSlotEnforce = invSlotEnforce;
        this.invFreeSlot = invFreeSlot;
        this.itemMaterial = itemMaterial;
        this.itemName = itemName;
        this.itemLore = itemLore;
        this.itemPlayerHeadEnable = itemPlayerHeadEnable;
        this.itemPlayerHeadPlayerWhoHasOpenedTheGUI = itemPlayerHeadPlayerWhoHasOpenedTheGUI;
        this.itemPlayerHeadPlayerName = itemPlayerHeadPlayerName;
        this.itemPlayerHeadBase64Enable = itemPlayerHeadBase64Enable;
        this.itemPlayerHeadBase64Value = itemPlayerHeadBase64Value;
        this.joinGiveOnEveryJoin = joinGiveOnEveryJoin;
        this.joinGiveOnlyOnFirstJoin = joinGiveOnlyOnFirstJoin;
        this.quitRemoveOnQuit = quitRemoveOnQuit;
        this.protectGameModeEnable = protectGameModeEnable;
        this.protectGameModeRemoveItemWhenItIsDisabled = protectGameModeRemoveItemWhenItIsDisabled;
        this.protectGameModeMode = protectGameModeMode;
        this.protectGameModeList = protectGameModeList;
        this.protectWorldEnable = protectWorldEnable;
        this.protectWorldRemoveItemWhenItIsDisabled = protectWorldRemoveItemWhenItIsDisabled;
        this.protectWorldMode = protectWorldMode;
        this.protectWorldList = protectWorldList;
    }
}
